from flask import Flask, render_template, jsonify, request
app = Flask(__name__)

# Vitals
vitalsHeartrate = -1
vitalsOxygen = -1
vitalsBodytemp = -1.0

@app.route('/api/vitals/heartrate')
def getVitalsHeartrate():
	returnArr = [ { 'heartrate': vitalsHeartrate } ]
	return jsonify(returnArr)

@app.route('/api/vitals/heartrate', methods=['POST'])
def setVitalsHeartrate():
	global vitalsHeartrate
	json = request.get_json()
	try:
		vitalsHeartrate = json['heartrate']
	except:
		return 'Incorrect usage.\nUsage: { heartrate: INT }\n', 400
	return 'Information set successfully', 204

@app.route('/api/vitals/oxygen')
def getVitalsOxygen():
	returnArr = [ { 'oxygen': vitalsOxygen } ]
	return jsonify(returnArr)

@app.route('/api/vitals/oxygen', methods=['POST'])
def setVitalsOxygen():
	global vitalsOxygen
	json = request.get_json()
	try:
		vitalsOxygen = json['oxygen']
	except:
		return 'Incorrect usage.\nUsage: { oxygen: INT }\n', 400
	return 'Information set successfully', 204

@app.route('/api/vitals/bodytemp')
def getVitalsBodytemp():
	returnArr = [ { 'bodytemp': vitalsBodytemp } ]
	return jsonify(returnArr)

@app.route('/api/vitals/bodytemp', methods=['POST'])
def setVitalsBodytemp():
	global vitalsBodytemp
	json = request.get_json()
	try:
		vitalsBodytemp = json['bodytemp']
	except:
		return 'Incorrect usage.\nUsage: { bodytemp: FLOAT }\n', 400
	return 'Information set successfully', 204

@app.route('/api/vitals')
def getVitals():
	returnArr = [ { 'heartrate': vitalsHeartrate, 'oxygen': vitalsOxygen, 'bodytemp': vitalsBodytemp } ]
	return jsonify(returnArr)

@app.route('/api/vitals', methods=['POST'])
def setVitals():
	global vitalsHeartrate
	global vitalsOxygen
	global vitalsBodytemp

	json = request.get_json()
	try:
		# This is a bit ugly but its just how I'm checking that everything is there without setting variables if the json is incorrect
		tempH = json['heartrate'] 
		tempO = json['oxygen']
		tempB = json['bodytemp']
		vitalsHeartrate = tempH
		vitalsOxygen = tempO
		vitalsBodytemp = tempB
	except:
		return 'Incorrect usage.\nUsage: { heartrate: INT, oxygen: INT, bodytemp: FLOAT }\n', 400
	return 'Information set successfully', 204

# Fitness
fitnessSteps = -1

@app.route('/api/fitness/steps')
def getSteps():
	return getFitness() # This is the same for now.

@app.route('/api/fitness/steps', methods=['POST'])
def setFitnessSteps():
	global fitnessSteps
	json = request.get_json()
	try:
		vitalsBodytemp = json['steps']
	except:
		return 'Incorrect usage.\nUsage: { steps: INT }\n', 400
	return 'Information set successfully', 204


@app.route('/api/fitness')
def getFitness():
	returnArr = [ { 'steps': fitnessSteps } ]
	return jsonify(returnArr)

@app.route('/api/fitness', methods=['POST'])
def setFitness():
	global fitnessSteps
	json = request.get_json()
	try:
		vitalsBodytemp = json['steps']
	except:
		return 'Incorrect usage.\nUsage: { steps: INT }\n', 400
	return 'Information set successfully', 204


# Cyberware management
#@app.route('/api/cyberware/add', methods=['POST'])
#def addCyberware


@app.route('/')
def uiindex():
	return render_template('index.html')
